%if 0%{?el7}
%define dist .el7
%endif

%define debug_package %{nil}

Name:		ffmpeg
Version:	3.2
Release:	2%{?dist}
Summary:	FFmpeg is a complete, cross-platform solution to record, convert and stream audio and video.

Packager:   momo-i <webmaster@momo-i.org>
Vendor:     momo-i, http://www.momo-i.org/

Group:		System Environment/Libraries
License:	Mixed
URL:		http://ffmpeg.org/
Source0:	http://ffmpeg.org/releases/%{name}-%{version}.tar.bz2
Source1:	http://ffmpeg.org/releases/%{name}-%{version}.tar.bz2.asc

BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

Conflicts:  ffmpeg0
Conflicts:  ffmpeg1
Conflicts:  ffmpeg2

Requires:       %{name}-libs = %{version}-%{release}

BuildRequires:	bzip2-devel yasm
BuildRequires:	libass-devel openjpeg-devel
BuildRequires:	libdc1394-devel
BuildRequires:	gsm-devel opencv-devel
BuildRequires:	libvorbis-devel
BuildRequires:	libX11-devel libXext-devel libXfixes-devel
BuildRequires:	fontconfig-devel
BuildRequires:	pkgconfig openssl-devel
BuildRequires:	SDL-devel texi2html texinfo
%if 0%{?rhel} >= 7 || 0%{?fedora} >= 22
BuildRequires:  SDL2-devel
%endif
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
BuildRequires:  libcdio-paranoia-devel
%else
BuildRequires:  libcdio-devel
%endif

%if 0%{?fedora} >= 21
BuildRequires:	perl-podlators
BuildRequires:  opencl-headers ocl-icd-devel
%endif

%if 0%{?fedora}
BuildRequires:  libmodplug-devel
BuildRequires:	frei0r-devel
%endif
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 6
BuildRequires:	celt-devel >= 0.11.0
BuildRequires:	libvpx-devel >= 0.9.7
BuildRequires:	speex-devel
BuildRequires:	gnutls-devel >= 2
BuildRequires:	pulseaudio-libs-devel
BuildRequires:	libtheora-devel
BuildRequires:	libbluray-devel
BuildRequires:	schroedinger-devel
BuildRequires:	openal-soft-devel
BuildRequires:	libv4l-devel
%endif

%if 0%{?fedora} >= 22
BuildRequires:  speexdsp-devel
BuildRequires:	opus-devel
%endif

## new package since rel 2
BuildRequires:  ladspa-devel libcaca-devel
BuildRequires:  libiec61883-devel
%if 0%{?fedora}
BuildRequires:  ilbc-devel
%endif
BuildRequires:  libssh-devel
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
BuildRequires:  wavpack-devel
%endif
BuildRequires:  zvbi-devel

BuildRequires:  libavc1394-devel libvdpau-devel

%if 0%{?fedora} >= 21 || 0%{?rhel} >= 6
BuildRequires:  game-music-emu-devel
%endif

## new package since ffmpeg version 2.2
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
BuildRequires:  libwebp-devel
BuildRequires:  ghc-OpenGL-devel
%endif

%if 0%{?fedora} >= 21 || 0%{?rhel} >= 6
BuildRequires:  czmq-devel
%endif

# new package since ffmpeg version 2.8
BuildRequires:  snappy-devel

# Original rpm packages
BuildRequires:	lame-devel
BuildRequires:	libnut-devel
BuildRequires:	libopencore-amr-devel
BuildRequires:	librtmp-devel
BuildRequires:	libvo-amrwbenc
BuildRequires:	libx264-devel
BuildRequires:	libxvidcore-devel
BuildRequires:	libopencore-amr-devel libopencore-amr
BuildRequires:	twolame-devel

## new original package since rel 2
BuildRequires:  vidstab-devel >= 0.98
BuildRequires:  fdk-aac
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 6
BuildRequires:  shine-devel
%endif

## new original package ffmpeg version 2.2
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
BuildRequires:  libx265-devel
%endif
BuildRequires:  decklink

# for 2.3
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
BuildRequires:  libbs2b-devel
%endif
BuildRequires:  libsmbclient-devel

# new original package ffmpeg version 2.7
# BuildRequires:  libdcadec-devel

# new original package ffmpeg version 2.8
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
BuildRequires:  libkvazaar-devel
%endif
BuildRequires:  libopenh264-devel

# new package ffmpeg version 3.0
%if 0%{?fedora} || 0%{?rhel} >= 7
BuildRequires:  libchromaprint-devel
%endif
%if 0%{?fedora} || 0%{?el6}
BuildRequires:  rubberband-devel
%endif
BuildRequires:  tesseract-devel
BuildRequires:  netcdf-devel
BuildRequires:  gmp-devel libgcrypt-devel

# new custom package ffmpeg version 3.0
%if 0%{?fedora} || 0%{?rhel} >= 7
BuildRequires:  libzimg-devel
%endif

%description
FFmpeg is a complete, cross-platform solution to record, convert and stream audio and video.

%package devel
Summary:	Libraries for FFmpeg
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}

%description devel
Libraries for FFmpeg

%package static
Summary:	Static libraries for FFmpeg
Group:		Development/Libraries

%description static
Static libraries for FFmpeg

%package -n ffplay
Summary:    FFplay media player
Group:      Applications/Multimedia
Requires:   %{name}-libs = %{version}-%{release}

%description -n ffplay
FFplay is a very simple and portable media player using the FFmpeg libraries and
the SDL library. It is mostly used as a testbed for the various FFmpeg APIs.

%package -n ffserver
Summary:    FFserver video server
Group:      System Environment/Daemons
Requires:   %{name}-libs = %{version}-%{release}

%description -n ffserver
ffserver is a streaming server for both audio and video.  It supports several
live feeds, streaming from files and time shifting on live feeds. You can seek to
positions in the past on each live feed, provided you specify a big enough feed
storage.

%package -n ffprobe
Summary:    FFprobe media prober
Group:      Applications/Multimedia
Requires:   %{name}-libs = %{version}-%{release}

%description -n ffprobe
ffprobe gathers information from multimedia streams and prints it in human- and
machine-readable fashion.

%package libs
Summary:    Common libraries for FFmpeg
Group:      System Environment/Libraries

%description libs
Common libraries for FFmpeg

%prep
%setup -q

%build
LDFLAGS="-lssl -lcrypto"
%ifarch x86_64
CFLAGS="-fPIC -m64"
%else
CFLAGS="-fPIC"
%endif
./configure \
	--prefix=%{_prefix} \
	--bindir=%{_bindir} \
	--datadir=%{_datadir}/ffmpeg \
	--incdir=%{_includedir} \
	--libdir=%{_libdir} \
	--shlibdir=%{_libdir} \
	--mandir=%{_mandir} \
	--extra-cflags="-fPIC -I%{_includedir}/samba-4.0" \
	--extra-ldflags="-lstdc++ -lsmbclient" \
	--enable-shared \
	--enable-gpl \
	--enable-version3 \
	--enable-nonfree \
	--enable-avresample \
	--enable-videotoolbox \
	--enable-bzlib \
	--enable-fontconfig \
	--enable-gcrypt \
	--enable-gmp \
	--enable-libopencore-amrnb \
	--enable-libopencore-amrwb \
	--enable-libdc1394 \
	--enable-libgsm \
	--enable-libmp3lame \
	--enable-libnut \
	--enable-libopenh264 \
	--enable-libopenjpeg \
	--enable-librtmp \
	--enable-libvorbis \
	--enable-libx264 \
	--enable-libxvid \
	--enable-memalign-hack \
	--extra-ldflags=-fPIC \
	--extra-cflags=-fPIC \
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
	--enable-chromaprint \
	--enable-libzimg \
	--enable-libwavpack \
	--enable-libbs2b \
	--enable-libwebp \
	--enable-libx265 \
	--enable-opengl \
	--enable-libkvazaar \
%endif
%if 0%{?fedora} >= 21
	--enable-libxcb \
	--enable-libxcb-shm \
	--enable-libxcb-xfixes \
	--enable-libxcb-shape \
	--enable-frei0r \
	--enable-libcelt \
	--enable-libvpx \
	--enable-libmodplug \
	--enable-libilbc \
	--enable-opencl \
%endif
%if 0%{?fedora} >= 21 || 0%{?el6}
	--enable-librubberband \
%endif
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 6
	--enable-libfribidi \
	--enable-libtesseract \
	--enable-libtheora \
	--enable-libass \
	--enable-libbluray \
	--enable-libv4l2 \
	--enable-netcdf \
	--enable-openal \
	--enable-libschroedinger \
	--enable-libpulse \
	--enable-gnutls \
	--enable-openssl \
	--enable-libspeex \
	--enable-libgme \
	--enable-libzmq \
	--enable-libshine \
	--enable-libsmbclient \
%endif
	--enable-libfdk-aac \
	--enable-pthreads \
	--enable-postproc \
	--enable-avfilter \
	--enable-x11grab \
	--enable-libopencv \
	--enable-libcdio \
	--enable-libfreetype \
	--enable-libvo-amrwbenc \
	--enable-libgsm \
	--enable-libtwolame \
%if 0%{?fedora} >= 22
	--enable-libopus \
%endif
	--enable-ladspa \
	--enable-libcaca \
	--enable-libiec61883 \
	--enable-libssh \
	--enable-libvidstab \
	--enable-libzvbi \
	--enable-pic \
	--enable-thumb \
	--enable-decklink \
	--enable-libfontconfig \
	--enable-libsnappy

make %{?_smp_mflags} V=1

%install
make install DESTDIR=%{buildroot} V=1
install -D -m0644 doc/ffserver.conf %{buildroot}%{_sysconfdir}/ffserver.conf

rm -rf $RPM_BUILD_ROOT%{_docdir}/ffmpeg

%files
%doc CREDITS* Changelog* INSTALL* MAINTAINERS* README* RELEASE* VERSION*
%{!?_licensedir:%global license %%doc}
%license COPYING* LICENSE*
%{_bindir}/ffmpeg
%{_mandir}/man1/ffmpeg.1*
%{_mandir}/man1/ffmpeg-all.1*
%{_datadir}/ffmpeg/*.ffpreset

%files libs
%{_mandir}/man1/ffmpeg-bitstream-filters.1*
%{_mandir}/man1/ffmpeg-codecs.1*
%{_mandir}/man1/ffmpeg-devices.1*
%{_mandir}/man1/ffmpeg-filters.1*
%{_mandir}/man1/ffmpeg-formats.1*
%{_mandir}/man1/ffmpeg-protocols.1*
%{_mandir}/man1/ffmpeg-resampler.1*
%{_mandir}/man1/ffmpeg-scaler.1*
%{_mandir}/man1/ffmpeg-utils.1*
%{_libdir}/*.so.*

%files -n ffplay
%if 0%{?rhel} >= 7 || 0%{?fedora} >= 22
%{_bindir}/ffplay
%{_mandir}/man1/ffplay.1*
%{_mandir}/man1/ffplay-all.1*
%endif

%files -n ffserver
%{_bindir}/ffserver
%{_mandir}/man1/ffserver.1*
%{_mandir}/man1/ffserver-all.1*
%config(noreplace) %{_sysconfdir}/ffserver.conf

%files -n ffprobe
%{_bindir}/ffprobe
%{_mandir}/man1/ffprobe.1*
%{_mandir}/man1/ffprobe-all.1*
%{_datadir}/ffmpeg/ffprobe.xsd

%files devel
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc
%{_includedir}/libavcodec/*.h
%{_includedir}/libavdevice/*.h
%{_includedir}/libavfilter/*.h
%{_includedir}/libavformat/*.h
%{_includedir}/libavresample/*.h
%{_includedir}/libavutil/*.h
%{_includedir}/libpostproc/*.h
%{_includedir}/libswresample/*.h
%{_includedir}/libswscale/*.h
%{_mandir}/man3/lib*.3*
%{_datadir}/ffmpeg/examples/*

%files static
%{_libdir}/*.a

%changelog
* Wed Nov 09 2016 momo-i <webmaster@momo-i.org> - 3.2-2
- Fix specfile

* Mon Oct 31 2016 momo-i <webmaster@momo-i.org> - 3.2-1
- Update to 3.2
- Remove libfaac
- Add libopenmpt

* Sun Oct 23 2016 momo-i <webmaster@momo-i.org> - 3.1.5-1
- Update to 3.1.5

* Mon Oct 10 2016 momo-i <webmaster@momo-i.org> - 3.1.4-1
- Update to 3.1.4

* Sun Sep 11 2016 momo-i <webmaster@momo-i.org> - 3.1.3-2
- Rebuilt for x265

* Sun Aug 28 2016 momo-i <webmaster@momo-i.org> - 3.1.3-1
- Update to 3.1.3

* Thu Aug 11 2016 momo-i <webmaster@momo-i.org> - 3.1.2-1
- Update to 3.1.2

* Thu Jul 07 2016 momo-i <webmaster@momo-i.org> - 3.1.1-1
- Update to 3.1.1

* Thu Jun 30 2016 momo-i <webmaster@momo-i.org> - 3.1-1
- Update to 3.1
- Remove dcadec

* Thu Apr 28 2016 momo-i <webmaster@momo-i.org> - 3.0.2-1
- Update to 3.0.2

* Tue Apr 26 2016 momo-i <webmaster@momo-i.org> - 3.0.1-2
- Re-enable fdk-aac for fc24

* Wed Mar 30 2016 momo-i <webmaster@momo-i.org> - 3.0.1-1
- Update to 3.0.1

* Tue Feb 16 2016 momo-i <webmaster@momo-i.org> - 3.0-1
- Update to 3.0
- Delete libaacplus, libvo-aacenc
- Add chromaprint, gcrypt, gmp, libzimg, libtesseract, netcdf, librubberband

* Wed Feb 10 2016 momo-i <webmaster@momo-i.org> - 2.8.6-2
- Rebuilt for x265

* Mon Feb 01 2016 momo-i <webmaster@momo-i.org> - 2.8.6-1
- Update to 2.8.6

* Thu Jan 21 2016 momo-i <webmaster@momo-i.org> - 2.8.5-2
- Rebuilt for kvazaar

* Sun Jan 17 2016 momo-i <webmaster@momo-i.org> - 2.8.5-1
- Update to 2.8.5

* Sun Dec 20 2015 momo-i <webmaster@momo-i.org> - 2.8.4-1
- Update to 2.8.4

* Mon Nov 30 2015 momo-i <webmaster@momo-i.org> - 2.8.3-1
- Update to 2.8.3

* Thu Nov 12 2015 momo-i <webmaster@momo-i.org> - 2.8.2-1
- Update to 2.8.2

* Mon Nov 02 2015 momo-i <webmaster@momo-i.org> - 2.8.1-4
- Test separate libraries

* Mon Nov 02 2015 momo-i <webmaster@momo-i.org> - 2.8.1-3
- Rebuilt for openh264

* Tue Oct 27 2015 momo-i <webmaster@momo-i.org> - 2.8.1-2
- Rebuilt for kvazaar

* Thu Oct 15 2015 momo-i <webmaster@momo-i.org> - 2.8.1-1
- Update to 2.8.1

* Tue Oct 13 2015 momo-i <webmaster@momo-i.org> - 2.8-6
- Rebuilt for x265

* Thu Oct 01 2015 momo-i <webmaster@momo-i.org> - 2.8-5
- Rebuilt for vidstab

* Mon Sep 14 2015 momo-i <webmaster@momo-i.org> - 2.8-4
- Add openh264 library

* Fri Sep 11 2015 momo-i <webmaster@momo-i.org> - 2.8-3
- Splitting of packages

* Fri Sep 11 2015 momo-i <webmaster@momo-i.org> - 2.8-2
- define debug_package nil

* Wed Sep 09 2015 momo-i <webmaster@momo-i.org> - 2.8-1
- Update to 2.8
- Add snappy kvazaar

* Thu Sep 03 2015 momo-i <webmaster@momo-i.org> - 2.7.2-21
- Update dist for centos7

* Mon Aug 10 2015 momo-i <webmaster@momo-i.org> - 2.7.2-20
- Rebuilt for fc23

* Tue Jul 28 2015 momo-i <webmaster@momo-i.org> - 2.7.2-19
- Rebuilt for x264

* Tue Jul 21 2015 momo-i <webmaster@momo-i.org> - 2.7.2-18
- Rebuilt for el7 libwebp

* Mon Jul 20 2015 momo-i <webmaster@momo-i.org> - 2.7.2-17
- Update to 2.7.2

* Fri Jul 03 2015 momo-i <webmaster@momo-i.org> - 2.7.1-17
- Rebuilt for x264

* Thu Jun 25 2015 momo-i <webmaster@momo-i.org> - 2.7.1-16
- Rebuilt for some encoders

* Mon Jun 22 2015 momo-i <webmaster@momo-i.org> - 2.7.1-15
- Update to 2.7.1

* Fri Jun 12 2015 momo-i <webmaster@momo-i.org> - 2.7-15
- Add dcadec

* Wed Jun 10 2015 momo-i <webmaster@momo-i.org> - 2.7-14
- Update to 2.7

* Fri Jun 05 2015 momo-i <webmaster@momo-i.org> - 2.6.3-13
- Rebuilt for x265

* Sun May 17 2015 momo-i <webmaster@momo-i.org> - 2.6.3-11
- Update to 2.6.3

* Fri Apr 17 2015 momo-i <webmaster@momo-i.org> - 2.6.2-10
- Rebuilt for fc22

* Mon Apr 13 2015 momo-i <webmaster@momo-i.org> - 2.6.2-9
- Update to 2.6.2

* Tue Mar 17 2015 momo-i <webmaster@momo-i.org> - 2.6.1-9
- Update to 2.6.1

* Mon Mar  9 2015 momo-i <webmaster@momo-i.org> - 2.6-9
- Update to 2.6
- disable opencl

* Tue Feb 17 2015 momo-i <webmaster@momo-i.org> - 2.5.4-9
- Update to 2.5.4

* Tue Jan 13 2015 momo-i <webmaster@momo-i.org> - 2.5.3-9
- Update to 2.5.3

* Wed Dec 24 2014 momo-i <webmaster@momo-i.org> - 2.5.2-9
- update to 2.5.2

* Tue Dec 16 2014 momo-i <webmaster@momo-i.org> - 2.5.1-9
- Update to 2.5.1

* Thu Dec  4 2014 momo-i <webmaster@momo-i.org> - 2.5-9
- Update to 2.5
- set flags for libsmbclient

* Mon Dec  1 2014 momo-i <webmaster@momo-i.org> - 2.4.4-9
- Update to 2.4.4

* Thu Nov 13 2014 momo-i <webmaster@momo-i.org> - 2.4.3-9
- Rebuilt for x264 and x265
- change license dir

* Wed Nov 12 2014 momo-i <webmaster@momo-i.org> - 2.4.3-8
- Rebuilt for el7

* Wed Nov  5 2014 momo-i <webmaster@momo-i.org> - 2.4.3-7
- Update to 2.4.3

* Tue Oct  7 2014 momo-i <webmaster@momo-i.org> - 2.4.2-7
- Update to 2.4.2

* Mon Sep 22 2014 momo-i <webmaster@momo-i.org> - 2.4.1-7
- Update to 2.4.1

* Wed Sep 17 2014 momo-i <webmaster@momo-i.org> - 2.4-7
- Update to 2.4

* Thu Aug 21 2014 momo-i <webmaster@momo-i.org> - 2.3.3-7
- Update to 2.3.3

* Thu Jul 17 2014 momo-i <webmaster@momo-i.org> - 2.3-7
- Update to 2.3

* Mon Jun 30 2014 momo-i <webmaster@momo-i.org> - 2.2.4-7
- Update to 2.2.4

* Wed Jun 18 2014 momo-i <webmaster@momo-i.org> - 2.2.3-7
- Update libx265

* Tue Jun  3 2014 momo-i <webmaster@momo-i.org> - 2.2.3-6
- Update to 2.2.3

* Wed May  7 2014 momo-i <webmaster@momo-i.org> - 2.2.2-6
- Update to 2.2.2

* Mon Apr 14 2014 momo-i <webmaster@momo-i.org> - 2.2.1-6
- Update to 2.2.1

* Mon Mar 24 2014 momo-i <webmaster@momo-i.org> - 2.2-6
- Update to 2.2
- Add libwebp libx265 decklink opengl

* Mon Feb 24 2014 momo-i <webmaster@momo-i.org> - 2.1.4-6
- Conflicts with ffmpeg version 0.x.x and 1.x.x

* Mon Feb 24 2014 momo-i <webmaster@momo-i.org> - 2.1.4-5
- Update to 2.1.4

* Thu Jan 23 2014 momo-i <webmaster@momo-i.org> - 2.1.3-5
- Update for x264

* Fri Jan 17 2014 momo-i <webmaster@momo-i.org> - 2.1.3-4
- Update to 2.1.3

* Tue Jan 14 2014 momo-i <webmaster@momo-i.org> - 2.1.2-4
- Update to 2.1.2
- Drop xavs support.

* Tue Dec 10 2013 momo-i <webmaster@momo-i.org> - 2.1.1-4
- Add OpenCL >= fedora19
- Add vdpau

* Tue Dec 10 2013 momo-i <webmaster@momo-i.org> - 2.1.1-3
- Fixed compile option to use fdk-aac

* Thu Dec  5 2013 momo-i <webmaster@momo-i.org> - 2.1.1-2
- Add new related packages based on fedora19
fdk-aac shine-devel vidstab-devel
ladspa-devel libcaca-devel
libiec61883-devel game-music-emu-devel
ilbc-devel libquvi-devel soxr-devel
libssh-devel wavpack-devel zvbi-devel

* Fri Nov 29 2013 momo-i <webmaster@momo-i.rog> - 2.1.1-1
- Update to 2.1.1

* Wed Nov 13 2013 momo-i <webmaster@momo-i.org> - 2.1-1
- Update to 2.1

* Thu Oct 17 2013 momo-i <webmaster@momo-i.org> - 2.0.2-1
- Update to 2.0.2

* Thu Aug 22 2013 momo-i <webmaster@momo-i.org> - 2.0.1-1
- Update to 2.0.1

* Wed Jul 17 2013 momo-i <webmaster@momo-i.org> 2.0-1
- Upgrade to 2.0.

* Mon Jul  8 2013 momo-i <webmaster@momo-i.org> 1.2.1-2
- Add some build require packages.

* Tue May 14 2013 momo-i <webmaster@momo-i.org> 1.2.1-1
- Update 1.2.1

* Tue Apr  9 2013 momo-i <webmaster@momo-i.org> 1.2-3
- Added static package.

* Wed Mar 27 2013 momo-i <webmaster@momo-i.org> 1.2-2
- forgot group name for devel package.

* Wed Mar 27 2013 momo-i <webmaster@momo-i.org> 1.2-1
- Initial rpm release.
